(function () {
    "use strict";

    angular.module('core').controller('categoriaFinanceiraController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'categoriaFinanceiraService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, categoriaFinanceiraService, lookupService) {
        $scope.initializeLayout('Categorias Financeiras');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    categoriaFinanceiraService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.refresh();

                                if (action == $scope.popups.add.saveAction.saveAndNew) {
                                    $scope.popups.add.toggle();
                                }
                                else if (action == $scope.popups.add.saveAction.saveAndEdit) {
                                    $scope.popups.edit.toggle(response.Data.ID);
                                }

                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                saveAction: { save: 0, saveAndNew: 1, saveAndEdit: 2 },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    categoriaFinanceiraService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.add.data = response.Data;
                                $scope.popups.add.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
            },
            edit: {
                ativo: false,
                data: {},
                tabs: { current: 0, subcategorias: 0, detalhes: 1 },
                save: function () {
                    $scope.state.salvando = true;
                    categoriaFinanceiraService
                        .save($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.get(id);
                    }
                },
                get: function (id) {
                    $scope.state.salvando = true;
                    categoriaFinanceiraService
                        .getCategoriaSuperior(id)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.edit.ativo = true;
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepare: function () {
                    $scope.state.salvando = true;
                    categoriaFinanceiraService
                        .prepare($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.edit.ativo = true;
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepareNewSubcategoria: function () {
                    categoriaFinanceiraService
                        .prepareNewSubcategoria($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.data = response.Data;
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                delete: function () {
                    $scope.state.salvando = true;
                    categoriaFinanceiraService
                        .delete($scope.popups.edit.data.ID)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
            },
        };
        $scope.auxiliar = {
            banco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllBanco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };
        $scope.presets = {
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {

            await $scope.clearFilter();

            var _original = {};
            await angular.copy($scope.state.filtro.original, _original);

            var filtro = $scope.localStorage.getItem('state.filtro');
            if (filtro) {
                await angular.copy(filtro, $scope.state.filtro);
                await angular.copy(_original, $scope.state.filtro.original);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original = Object.assign($scope.state.filtro.original, {
                sortExpression: $scope.state.filtro.args.sortExpression,
                skip: $scope.state.filtro.args.skip,
                take: $scope.state.filtro.args.take
            });
            $scope.state.filtro.hasChanges = !angular.equals($scope.state.filtro.original, $scope.state.filtro.args);

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro', $scope.state.filtro);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                await $scope.innerRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.afterRefresh();
            }
            catch (error) {
                $scope.clearFilter();
            } finally {
                $scope.$apply();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: { IndicaAnalitica: false },
                    filtroDe: null,
                    filtroAte: null,
                    sortExpression: '[Codigo]',
                    skip: 0,
                    take: 20
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.getAll();
            await $scope.count();
        };

        $scope.getAll = async () => {
            $scope.state.completo = false;
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            try {
                const response = await categoriaFinanceiraService.getAll($scope.state.filtro.args);
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = !($scope.state.data && $scope.state.data.length > 0);
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            }
            finally {
                $scope.state.carregando = false;
            }
        };
        $scope.count = async () => {
            try {
                const response = await categoriaFinanceiraService.count($scope.state.filtro.args);

                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            } finally {
                $scope.$apply();
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo) {
                $scope.state.carregandoMais = true;
                try {

                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
                    let response = await categoriaFinanceiraService.getAll($scope.state.filtro.args)

                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                        $scope.state.completo = !(response.Data && response.Data.length > 0);
                    }
                } catch (err) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(err);
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$apply();
                }
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();